/*=== Ir Remote controler for IO-Data  (abc857) ===*/

#include "mcc_generated_files/mcc.h"

#define	MARK()      __delay_us(562)
#define SPACE_1()   __delay_us(1686)
#define SPACE_0()   __delay_us(562)
#define LEADER_1()  __delay_us(8992)
#define LEADER_0()  __delay_us(4496)
#define GYAP_0()    __delay_ms(43)

#define DSM_1()		(MD1CON0bits.MD1BIT = 1)
#define DSM_0()		(MD1CON0bits.MD1BIT = 0)

#define IO_CUSTOM	0xE880

#define SCN_DELAY() __delay_ms(30)
#define KEY_DELAY() __delay_ms(500)

uint8_t IO[][8] ={{0x80,0xE8,0x84,0x7B,0x80,0xE8,0x10,0xCF},
                  {0x80,0xE8,0x84,0x7B,0x80,0xE8,0x20,0xCF},
                  {0x80,0xE8,0x84,0x7B,0x80,0xE8,0x30,0xCF}};
			
uint16_t IO2[]  = {0x1084,0x4084,0x7084,0x7024,     // 1,4,7,t-digi
                   0x2084,0x5084,0x8084,0xA084,     // 2,5,8,10
                   0x3084,0x6084,0x9084,0x0094};    // 3,6,9,BS

uint8_t  sft;
uint16_t wsft;
uint16_t keyM;
uint8_t  keyP;
//uint16_t ky;

/*---- IOdata Leader ---*/
void IO_Leader(){
	DSM_1();                // "Leader" Start
	LEADER_1();
	DSM_0();
	LEADER_0();
}

/*---- IOdata stop ---*/
void IO_Stop(){
	DSM_1();
	MARK();                 // "Stop"
	DSM_0();
}

/*--- Send strings of IRcode -----*/
void Ir_Send(uint8_t *dt,uint8_t x){
	for (int j=0;j<x;j++){
	    sft = 0x01;
	    for(int i=0;i<8;i++){
		    DSM_1();
			MARK();
			DSM_0();
			if(dt[j] & sft){
		        SPACE_1();
			}else{
		        SPACE_0();
			}
			sft <<= 1;
	    }
	}
}
/*------- Send IOdata code -------*/
void IO_DATA(uint8_t c){
	IO_Leader();          // "Leader" Start
	Ir_Send(&IO[c][0],4); // Send "Data1"
	IO_Stop();			 // "Stop"
	GYAP_0();             // Gyap time
	IO_Leader();           // "Leader" Start
	Ir_Send(&IO[c][4],4);  // Send "Datae2"
	IO_Stop();		 	 // Stop
}

/*-------- Send word of IRcode ------*/
void Ir_Send2(uint16_t wd){
	wsft = 0x0001;
	for(int i=0;i<16;i++){
	    DSM_1();
	    MARK();
	    DSM_0();
	    if(wd & wsft){
	    		SPACE_1();
	    }else{
	    		SPACE_0();
		}
	    wsft <<= 1;
	}
}

/*-------- Send IOdata2 IRcode  ----*/
void IO_DATA2(uint8_t c){
    uint16_t w = IO2[c];
	uint16_t wLo=(w&0x00FF)|((~w<<8)&0xFF00);
	uint16_t wHi=((w>>8)&0x00FF)|(~w&0xFF00);
	IO_Leader();          // "Leader" Start
	Ir_Send2(IO_CUSTOM);	 // Send "Custom" 
	Ir_Send2(wLo);        // Send "Data1"
	IO_Stop();			 // stop
	GYAP_0();             // Gyap time
	IO_Leader();          // "Leader" Start
	Ir_Send2(IO_CUSTOM);	 // Send "Custom" 
	Ir_Send2(wHi);        // Send "Data2"
	IO_Stop();			 // stop
}


uint16_t keyScan(){
    uint8_t k;
    uint16_t ky;
    X_A0_SetLow();
    SCN_DELAY();
    ky = ~PORTC & 0x0F;
    X_A0_SetHigh();    

    Y_A1_SetLow();
    SCN_DELAY();
    k = ~PORTC & 0x0F;
    ky |= ((uint16_t)k << 4);
    Y_A1_SetHigh();    

    Z_A2_SetLow();     
    SCN_DELAY();
    k = ~PORTC & 0x0F;
    ky |= ((uint16_t)k << 8);
    Z_A2_SetHigh();    
    return ky; 
}

uint8_t bitCount(uint16_t w){
    uint16_t wsft = 1;
    uint8_t i;
    for (i = 0; i < 12; i++){
        if(w & wsft)   return (i);
        wsft <<= 1;
    }
    return 0;
}

/* =====  Main application ====== */

void main(void)
{
    SYSTEM_Initialize();
    
    X_A0_SetHigh();
    Y_A1_SetHigh();
    Z_A2_SetHigh();
    LED_C4_SetHigh();
    
    while (1){
        keyM = keyScan();
        if(keyM){
            keyP = bitCount(keyM);
            IO_DATA2(keyP);
            KEY_DELAY();
        }
    }
}
/* ===== End of File ===== */
